/*
 *  Project   : tin - a visual threaded usenet newsreader
 *  Module    : lang.h
 *  Author    : I.Lea
 *  Created   : 01-04-91
 *  Updated   : 10-10-91
 *  Release   : 1.0
 *  Notes     :
 *  Copyright : (c) Copyright 1991 by Iain Lea
 *	            You may  freely  copy or  redistribute  this software,
 *              so  long as there is no profit made from its use, sale
 *              trade or  reproduction.  You may not change this copy-
 *              right notice, and it must be included in any copy made
 */

/*
 *  art.c
 */

extern char txt_group[];
extern char txt_cannot_open_art[];
extern char txt_indexing[];
extern char txt_indexing_num[];
extern char txt_corrupt_index[];
extern char txt_checking_for_news[];
extern char txt_there_is_no_news[];
extern char txt_killing_arts[];
extern char txt_unkilling_arts[];

/*
 *  feed.c
 */

extern char txt_art_thread_regex_tag[];
extern char txt_post_procees_type[];
extern char txt_feed_pattern[];
extern char txt_no_command[];
extern char txt_piping[];

/*
 *  group.c
 */

extern char txt_cannot_post[];
extern char txt_tagged_art[];
extern char txt_untagged_art[];
extern char txt_inverse_on[];
extern char txt_inverse_off[];
extern char txt_subscribed_to[];
extern char txt_unsubscribed_to[];
extern char txt_mark_all_read[];
extern char txt_no_more_groups[];
extern char txt_no_prev_group[];
extern char txt_no_arts[];
extern char txt_no_groups[];
extern char txt_end_of_arts[];
extern char txt_end_of_groups[];
extern char txt_no_next_unread_art[];
extern char txt_no_prev_unread_art[];
extern char txt_no_last_message[];
extern char txt_bad_command[];
extern char txt_you_have_mail[];
extern char txt_type_h_for_help[];
extern char txt_read_art[];
extern char txt_author_search_forwards[];
extern char txt_author_search_backwards[];
extern char txt_search_forwards[];
extern char txt_search_backwards[];
extern char txt_no_search_string[];
extern char txt_no_match[];
extern char txt_post_subject[];
extern char txt_no_subject[];
extern char txt_cannot_open[];
extern char txt_posting[];
extern char txt_art_posted[];
extern char txt_art_rejected[];
extern char txt_abort_edit_post[];
extern char txt_index_page_com[];
extern char txt_help_i_4[];
extern char txt_help_ctrl_k[];
extern char txt_help_ctrl_l[];
extern char txt_help_ctrl_d[];
extern char txt_help_i_cr[];
extern char txt_help_i_tab[];
extern char txt_help_m[];
extern char txt_help_M[];
extern char txt_help_a[];
extern char txt_help_sel_c[];
extern char txt_help_c[];
extern char txt_help_g[];
extern char txt_help_I[];
extern char txt_help_K[];
extern char txt_help_j[];
extern char txt_help_i_n[];
extern char txt_help_i_p[];
extern char txt_help_q[];
extern char txt_help_s[];
extern char txt_help_S[];
extern char txt_help_t[];
extern char txt_help_T[];
extern char txt_help_U[];
extern char txt_help_v[];
extern char txt_help_w[];
extern char txt_help_i_search[];
extern char txt_help_thread[];
extern char txt_help_dash[];
extern char txt_save_pattern[];
extern char txt_saved_pattern_to[];
extern char txt_saved_to_mailbox[];
extern char txt_switch_on_kill_art_menu[];

/* 
 *  help.c:
 */

extern char txt_post_history_menu[];
extern char txt_hit_space_for_more[];

/* 
 *  kill.c:
 */

extern char txt_kill_menu[];
extern char txt_kill_subject[];
extern char txt_kill_from[];
extern char txt_kill_text[];
extern char txt_kill_text_type[];
extern char txt_kill_group[];
extern char txt_help_kill_subject[];
extern char txt_help_kill_from[];
extern char txt_help_kill_text[];
extern char txt_help_kill_text_type[];
extern char txt_help_kill_group[];
extern char txt_abort_edit_save_killfile[];

/*
 *  page.c
 */

extern char txt_quit[];
extern char txt_art_unavailable[];
extern char txt_art_marked_as_unread[];
extern char txt_thread_marked_as_unread[];
extern char txt_begin_of_art[];
extern char txt_next_resp[];
extern char txt_last_resp[];
extern char txt_more_percent[];
extern char txt_more[];
extern char txt_thread_x_of_n[];
extern char txt_art[];
extern char txt_resp_x_of_n[];
extern char txt_no_resp[];
extern char txt_1_resp[];
extern char txt_x_resp[];
extern char txt_s_at_s[];
extern char txt_thread_resp_page[];
extern char txt_thread_page[];
extern char txt_read_resp[];
extern char txt_art_pager_com[];
extern char txt_help_p_0[];
extern char txt_help_p_4[];
extern char txt_help_p_cr[];
extern char txt_help_p_tab[];
extern char txt_help_b[];
extern char txt_help_C[];
extern char txt_help_bug[];
extern char txt_help_p_f[];
extern char txt_help_ctrl_h[];
extern char txt_help_h[];
extern char txt_help_p_i[];
extern char txt_help_p_k[];
extern char txt_help_p_m[];
extern char txt_help_p_n[];
extern char txt_help_o[];
extern char txt_help_p_p[];
extern char txt_help_p_r[];
extern char txt_help_p_s[];
extern char txt_help_p_z[];
extern char txt_help_p_ctrl_r[];
extern char txt_help_p_g[];
extern char txt_help_p_d[];
extern char txt_help_pipe[];
extern char txt_help_p_search[];
extern char txt_mail_art_to[];
extern char txt_no_mail_address[];
extern char txt_abort_edit_send[];
extern char txt_abort_edit_cancel[];
extern char txt_cancelling[];
extern char txt_art_cancelled[];
extern char txt_mailing_to[];
extern char txt_message_sent[];
extern char txt_command_failed_s[];
extern char txt_in_art_you_write[];
extern char txt_resp_to_poster[];
extern char txt_resp_redirect[];
extern char txt_continue[];
extern char txt_writes[];
extern char txt_save_filename[];
extern char txt_art_not_saved[];
extern char txt_no_filename[];
extern char txt_saving[];
extern char txt_art_saved_to[];
extern char txt_thread_not_saved[];
extern char txt_thread_saved_to_many[];
extern char txt_thread_saved_to[];
extern char txt_pipe_to_command[];
extern char txt_command_failed[];
extern char txt_printing[];
extern char txt_printed[];
extern char txt_append_to_file[];

/*
 *  prompt.c
 */

extern char txt_hit_any_key[];
 
/* 
 *  main.c:
 */

extern char txt_not_in_active_file[];
extern char txt_screen_init_failed[];
extern char txt_bad_active_file[];

/*
 *  misc.c
 */

extern char txt_cannot_find_base_art[];
extern char txt_out_of_memory[];
extern char txt_rename_error[];
extern char txt_shell_escape[];

/*
 *  nntp.c
 */

extern char txt_cannot_get_nntp_server_name[];
extern char txt_server_name_in_file_env_var[];
extern char txt_failed_to_connect_to_server[];
extern char txt_rejected_by_nntpserver[];
extern char txt_connection_to_server_broken[];
extern char txt_stuff_nntp_cannot_open[];
extern char txt_nntp_to_fp_cannot_reopen[];
extern char txt_nntp_to_fd_cannot_reopen[];
extern char txt_toggled_rot13[];

/*
 *  post.c
 */

extern char txt_no_arts_posted[];
extern char txt_post_an_article[];
extern char txt_post_a_followup[];
extern char txt_mail_bug_report[];
extern char txt_reply_to_author[];

/*
 *  rcfile.c
 */

extern char txt_opt_autosave[];
extern char txt_opt_save_separate[];
extern char txt_opt_mark_saved_read[];
extern char txt_opt_kill_articles[];
extern char txt_opt_show_author[];
extern char txt_opt_draw_arrow[];
extern char txt_opt_post_process[];
extern char txt_opt_print_header[];
extern char txt_opt_pos_first_unread[];
extern char txt_opt_process_type[];
extern char txt_opt_sort_type[];
extern char txt_post_process_none[];
extern char txt_post_process_sh[];
extern char txt_post_process_uudecode[];
extern char txt_post_process_uud_lst_zoo[];
extern char txt_post_process_uud_ext_zoo[];
extern char txt_post_process_patch[];
extern char txt_sort_by_nothing[];
extern char txt_sort_by_subj_descend[];
extern char txt_sort_by_subj_ascend[];
extern char txt_sort_by_from_descend[];
extern char txt_sort_by_from_ascend[];
extern char txt_sort_by_date_descend[];
extern char txt_sort_by_date_ascend[];
extern char txt_opt_savedir[];
extern char txt_opt_maildir[];
extern char txt_opt_printer[];
extern char txt_options_menu[];
extern char txt_help_autosave[];
extern char txt_help_save_separate[];
extern char txt_help_print_header[];
extern char txt_help_pos_first_unread[];
extern char txt_help_show_author[];
extern char txt_help_draw_arrow[];
extern char txt_help_kill_articles[];
extern char txt_help_mark_saved_read[];
extern char txt_help_post_proc_type[];
extern char txt_help_sort_type[];
extern char txt_help_savedir[];
extern char txt_help_maildir[];
extern char txt_help_printer[];
extern char txt_select_rcfile_option[];

/*
 *  save.c
 */

extern char txt_post_processing[];
extern char txt_post_processing_finished[];
extern char txt_deleting[];
extern char txt_uudecoding[];

/*
 *  search.c
 */

extern char txt_searching[];

/*
 *  select.c
 */

extern char txt_moving[];
extern char txt_subscribe_pattern[];
extern char txt_unsubscribe_pattern[];
extern char txt_subscribing[];
extern char txt_subscribing_to[];
extern char txt_unsubscribing[];
extern char txt_unsubscribing_from[];
extern char txt_subscribed_num_groups[];
extern char txt_unsubscribed_num_groups[];
extern char txt_del_group_in_newsrc[];
extern char txt_group_deleted[];
extern char txt_group_undeleted[];
extern char txt_mark_group_read[];
extern char txt_no_groups_to_delete[];
extern char txt_reset_newsrc[];
extern char txt_no_groups_to_read[];
extern char txt_added_groups[];
extern char txt_plural[];
extern char txt_no_groups_to_yank_in[];
extern char txt_group_selection[];
extern char txt_select_group[];
extern char txt_group_select_com[];
extern char txt_help_g_4[];
extern char txt_help_g_ctrl_r[];
extern char txt_help_g_ctrl_k[];
extern char txt_help_g_cr[];
extern char txt_help_g_tab[];
extern char txt_help_g_c[];
extern char txt_help_W[];
extern char txt_help_g_y[];
extern char txt_help_g_z[];
extern char txt_help_g_dollar[];
extern char txt_help_g_search[];
extern char txt_newsgroup[];
extern char txt_newsgroup_position[];

/*
 *  signal.c
 */

extern char txt_resizing_window[];
