#ifdef __STDC__
 
/* art.c */
long my_atol(char *s, int n);
void find_base(void);
int num_of_arts(void);
int valid_artnum(long art);
int purge_needed(void);
void index_group(char *group, char *group_path);
int read_group(char *group, char *group_path);
void make_threads(int rethread);
char *eat_re(char *s);
long hash_s(char *s);
int parse_headers(int fd, struct header *h);
void dump_index(char *group, int killed);
void my_strncpy(char *p, char *q, int n);
int load_index(void);
void find_local_index(char *group);
void do_update(void);
int check_start_save_any_news(int check_start_save);
void reload_index_file(char *group, int killed);
char *parse_date(char *date, char *str);
int artnum_comp(char *p1, char *p2);
int subj_comp(char *p1, char *p2);
int from_comp(char *p1, char *p2);
int date_comp(char *p1, char *p2);
void set_article(struct header *art);
/* curses.c */
int InitScreen(void);
void ScreenSize(int *num_lines, int *num_columns);
void EndWin(void);
void ClearScreen(void);
void MoveCursor(int row, int col);
void CleartoEOLN(void);
void CleartoEOS(void);
void StartInverse(void);
void EndInverse(void);
int RawState(void);
void Raw(int state);
int ReadCh(void);
int outchar(int c);
/* debug.c */
void debug_print_arts(void);
void debug_print_header(struct header *s);
void debug_print_comment(char *comment);
void debug_print_base(void);
void debug_print_active(void);
/* feed.c */
void feed_articles(int function, int level, char *prompt, int respnum, char *group_path);
/* group.c */
void group_page(char *group);
void fix_new_highest(int groupnum);
void show_group_page(char *group);
void draw_subject_arrow(void);
void erase_subject_arrow(void);
int prompt_subject_num(int ch, char *group);
int new_responses(int thread);
void clear_note_area(void);
int find_new_pos(int old_top, long old_artnum, int cur_pos);
int mark_screen(int col, char *value);
/* hashstr.c */
char *hash_str(char *s);
struct hashnode *add_string(char *s);
void hash_init(void);
void hash_reclaim(void);
/* help.c */
void show_info_page(int type, char *help[], char *title);
void help_select_info(void);
void help_group_info(void);
void help_page_info(void);
/* kill.c */
int read_kill_file(void);
void write_kill_file(void);
int kill_art_menu(char *group_name, int index);
int untag_all_articles(void);
int kill_any_articles(char *group);
/* lang.c */
/* main.c */
void main(int argc, char *argv[]);
void usage(char *progname);
/* memory.c */
void init_alloc(void);
void expand_art(void);
void free_art_array(void);
void expand_active(void);
void expand_kill(void);
void expand_save(void);
void init_screen_array(int allocate);
void free_all_arrays(void);
void free_kill_array(void);
void free_save_array(void);
char *my_malloc(unsigned size);
char *my_realloc(char *p, unsigned size);
/* misc.c */
void init_selfinfo(void);
int which_base(int n);
int which_resp(int n);
int nresp(int n);
void asfail(char *file, int line, char *cond);
void copy_fp(FILE *a, FILE *b, char *prefix);
char *get_val(char *env, char *def);
int invoke_editor(char *nam);
void shell_escape(void);
void tin_done(int ret);
int read_active(void);
void mark_unthreaded_groups(void);
int backup_active(int create);
void add_signature(FILE *fp, int flag);
long hash_groupname(char *buf);
void rename_file(char *old_filename, char *new_filename);
char *str_dup(char *str);
int invoke_cmd(char *nam);
void draw_percent_mark(int cur_num, int max_num);
void set_real_uid_gid(void);
void set_tin_uid_gid(void);
void notify_groups(void);
void basename(char *dirname, char *program);
void mail_setup(void);
int mail_check(void);
/* newsrc.c */
void backup_newsrc(void);
void read_newsrc(int sub_only);
void write_newsrc(void);
void rewrite_newsrc(void);
void read_newsrc_line(char *group);
void update_newsrc(char *group, int groupnum, int mark_unread);
void subscribe(char *group, int ch, int num, int out_seq);
void reset_newsrc(void);
void delete_group(char *group);
int undel_group(void);
void mark_group_read(char *group, int groupnum);
void parse_seq(char *s);
int parse_unread(char *s, int groupnum);
int get_line_unread(char *group, int groupnum);
void print_seq(FILE *fp, int groupnum);
int pos_group_in_newsrc(char *group, int pos);
void mark_all_xref_read(char *xref_line);
/* open.c */
char *is_remote(void);
void nntp_startup(void);
void nntp_finish(void);
FILE *open_active_fp(void);
FILE *open_art_fp(char *group_path, long art);
int open_header_fd(char *group_path, long art);
int base_comp(char *p1, char *p2);
void setup_base(char *group, char *group_path);
int get_respcode(void);
int stuff_nntp(char *fnam);
FILE *nntp_to_fp(void);
int nntp_to_fd(void);
/* page.c */
int show_page(int respnum, char *group, char *group_path);
void redraw_page(int respnum, char *group);
void show_note_page(int respnum, char *group);
void show_first_header(int respnum, char *group);
void show_cont_header(int respnum);
void art_open(long art, char *group_path);
void art_close(void);
int prompt_response(int ch, int respnum);
int choose_resp(int i, int n);
void parse_from(char *str, char *addr, char *name);
int prev_response(int n);
int next_response(int n);
int next_basenote(int n);
void yank_to_addr(char *orig, char *addr);
int show_last_page(void);
int match_header(char *buf, char *pat, char *body, int len);
/* post.c */
int user_posted_messages(void);
void update_art_posted_file(char *group, char *subj);
int post_base(char *group);
int post_response(char *group, int respnum);
int mail_to_someone(char *address);
int mail_bug_report(void);
int mail_to_author(int copy_text);
void find_new_to(char *nam, char *mail_to);
int cancel_article(void);
int submit_file(char *name);
/* prompt.c */
int parse_num(int ch, char *prompt);
int parse_string(char *prompt, char *buf);
int parse_menu_string(int line, int col, char *var);
int prompt_yn(int line, char *prompt, int default_ch);
void continue_prompt(void);
/* rcfile.c */
int read_rcfile(void);
void write_rcfile(void);
int change_rcfile(char *group, int kill_at_once);
void show_rcfile_menu(void);
void expand_rel_abs_pathname(int line, int col, char *str);
void show_menu_help(char *help_message);
/* save.c */
int save_art_to_file(int respnum, int index, int mailbox, char *filename);
int save_thread_to_file(int is_mailbox, char *group_path);
int save_regex_arts(int is_mailbox, char *group_path);
int append_to_existing_file(int i);
int create_path(char *path);
int create_sub_dir(int i);
void add_to_save_list(int index, struct header *article, int is_mailbox, char *path);
void sort_save_list(void);
int save_comp(char *p1, char *p2);
char *save_filename(int i);
char *get_first_savefile(void);
char *get_last_savefile(void);
int post_process_files(int proc_type_ch);
void post_process_uud(int pp);
void post_process_sh(void);
char *get_archive_file(char *dir, char *ext);
void delete_processed_files(void);
void post_process_patch(void);
/* screen.c */
void info_message(char *str);
void wait_message(char *str);
void error_message(char *template, char *str);
void clear_message(void);
void center_line(int line, int inverse, char *str);
void draw_arrow(int line);
void erase_arrow(int line);
/* search.c */
int search_author(int current_art, int forward);
void search_group(int forward);
void search_subject(int forward, char *group);
int search_article(int forward);
char *str_str(char *text, char *pattern);
void make_lower(char *s, char *t);
/* select.c */
void selection_index(int start_groupnum);
void group_selection_page(void);
int prompt_group_num(int ch);
void erase_group_arrow(void);
void draw_group_arrow(void);
int choose_new_group(void);
int add_group(char *s, int get_unread);
int next_unread(int n);
int prev_unread(int n);
int reposition_group(char *group, int default_num);
void catchup_group(int goto_next_unread_group);
void next_unread_group(int enter_group);
/* signal.c */
void set_signal_handlers(void);
void signal_handler(int sig);
void set_win_size(int *num_lines, int *num_cols);
void art_suspend(int sig);
void main_suspend(int sig);
void select_suspend(int sig);
void group_suspend(int sig);
void page_suspend(int sig);
void rcfile_suspend(int sig);
void art_resize(int sig);
void main_resize(int sig);
void select_resize(int sig);
void group_resize(int sig);
void page_resize(int sig);
/* wildmat.c */
int wildmat(char *text, char *p);
 
#else
 
/* art.c */
long my_atol(/*char *s, int n*/);
void find_base(/*void*/);
int num_of_arts(/*void*/);
int valid_artnum(/*long art*/);
int purge_needed(/*void*/);
void index_group(/*char *group, char *group_path*/);
int read_group(/*char *group, char *group_path*/);
void make_threads(/*int rethread*/);
char *eat_re(/*char *s*/);
long hash_s(/*char *s*/);
int parse_headers(/*int fd, struct header *h*/);
void dump_index(/*char *group, int killed*/);
void my_strncpy(/*char *p, char *q, int n*/);
int load_index(/*void*/);
void find_local_index(/*char *group*/);
void do_update(/*void*/);
int check_start_save_any_news(/*int check_start_save*/);
void reload_index_file(/*char *group, int killed*/);
char *parse_date(/*char *date, char *str*/);
int artnum_comp(/*char *p1, char *p2*/);
int subj_comp(/*char *p1, char *p2*/);
int from_comp(/*char *p1, char *p2*/);
int date_comp(/*char *p1, char *p2*/);
void set_article(/*struct header *art*/);
/* curses.c */
int InitScreen(/*void*/);
void ScreenSize(/*int *num_lines, int *num_columns*/);
void EndWin(/*void*/);
void ClearScreen(/*void*/);
void MoveCursor(/*int row, int col*/);
void CleartoEOLN(/*void*/);
void CleartoEOS(/*void*/);
void StartInverse(/*void*/);
void EndInverse(/*void*/);
int RawState(/*void*/);
void Raw(/*int state*/);
int ReadCh(/*void*/);
int outchar(/*int c*/);
/* debug.c */
void debug_print_arts(/*void*/);
void debug_print_header(/*struct header *s*/);
void debug_print_comment(/*char *comment*/);
void debug_print_base(/*void*/);
void debug_print_active(/*void*/);
/* feed.c */
void feed_articles(/*int function, int level, char *prompt, int respnum, char *group_path*/);
/* group.c */
void group_page(/*char *group*/);
void fix_new_highest(/*int groupnum*/);
void show_group_page(/*char *group*/);
void draw_subject_arrow(/*void*/);
void erase_subject_arrow(/*void*/);
int prompt_subject_num(/*int ch, char *group*/);
int new_responses(/*int thread*/);
void clear_note_area(/*void*/);
int find_new_pos(/*int old_top, long old_artnum, int cur_pos*/);
int mark_screen(/*int col, char *value*/);
/* hashstr.c */
char *hash_str(/*char *s*/);
struct hashnode *add_string(/*char *s*/);
void hash_init(/*void*/);
void hash_reclaim(/*void*/);
/* help.c */
void show_info_page(/*int type, char *help[], char *title*/);
void help_select_info(/*void*/);
void help_group_info(/*void*/);
void help_page_info(/*void*/);
/* kill.c */
int read_kill_file(/*void*/);
void write_kill_file(/*void*/);
int kill_art_menu(/*char *group_name, int index*/);
int untag_all_articles(/*void*/);
int kill_any_articles(/*char *group*/);
/* lang.c */
/* main.c */
void main(/*int argc, char *argv[]*/);
void usage(/*char *progname*/);
/* memory.c */
void init_alloc(/*void*/);
void expand_art(/*void*/);
void free_art_array(/*void*/);
void expand_active(/*void*/);
void expand_kill(/*void*/);
void expand_save(/*void*/);
void init_screen_array(/*int allocate*/);
void free_all_arrays(/*void*/);
void free_kill_array(/*void*/);
void free_save_array(/*void*/);
char *my_malloc(/*unsigned size*/);
char *my_realloc(/*char *p, unsigned size*/);
/* misc.c */
void init_selfinfo(/*void*/);
int which_base(/*int n*/);
int which_resp(/*int n*/);
int nresp(/*int n*/);
void asfail(/*char *file, int line, char *cond*/);
void copy_fp(/*FILE *a, FILE *b, char *prefix*/);
char *get_val(/*char *env, char *def*/);
int invoke_editor(/*char *nam*/);
void shell_escape(/*void*/);
void tin_done(/*int ret*/);
int read_active(/*void*/);
void mark_unthreaded_groups(/*void*/);
int backup_active(/*int create*/);
void add_signature(/*FILE *fp, int flag*/);
long hash_groupname(/*char *buf*/);
void rename_file(/*char *old_filename, char *new_filename*/);
char *str_dup(/*char *str*/);
int invoke_cmd(/*char *nam*/);
void draw_percent_mark(/*int cur_num, int max_num*/);
void set_real_uid_gid(/*void*/);
void set_tin_uid_gid(/*void*/);
void notify_groups(/*void*/);
void basename(/*char *dirname, char *program*/);
void mail_setup(/*void*/);
int mail_check(/*void*/);
/* newsrc.c */
void backup_newsrc(/*void*/);
void read_newsrc(/*int sub_only*/);
void write_newsrc(/*void*/);
void rewrite_newsrc(/*void*/);
void read_newsrc_line(/*char *group*/);
void update_newsrc(/*char *group, int groupnum, int mark_unread*/);
void subscribe(/*char *group, int ch, int num, int out_seq*/);
void reset_newsrc(/*void*/);
void delete_group(/*char *group*/);
int undel_group(/*void*/);
void mark_group_read(/*char *group, int groupnum*/);
void parse_seq(/*char *s*/);
int parse_unread(/*char *s, int groupnum*/);
int get_line_unread(/*char *group, int groupnum*/);
void print_seq(/*FILE *fp, int groupnum*/);
int pos_group_in_newsrc(/*char *group, int pos*/);
void mark_all_xref_read(/*char *xref_line*/);
/* open.c */
char *is_remote(/*void*/);
void nntp_startup(/*void*/);
void nntp_finish(/*void*/);
FILE *open_active_fp(/*void*/);
FILE *open_art_fp(/*char *group_path, long art*/);
int open_header_fd(/*char *group_path, long art*/);
int base_comp(/*char *p1, char *p2*/);
void setup_base(/*char *group, char *group_path*/);
int get_respcode(/*void*/);
int stuff_nntp(/*char *fnam*/);
FILE *nntp_to_fp(/*void*/);
int nntp_to_fd(/*void*/);
/* page.c */
int show_page(/*int respnum, char *group, char *group_path*/);
void redraw_page(/*int respnum, char *group*/);
void show_note_page(/*int respnum, char *group*/);
void show_first_header(/*int respnum, char *group*/);
void show_cont_header(/*int respnum*/);
void art_open(/*long art, char *group_path*/);
void art_close(/*void*/);
int prompt_response(/*int ch, int respnum*/);
int choose_resp(/*int i, int n*/);
void parse_from(/*char *str, char *addr, char *name*/);
int prev_response(/*int n*/);
int next_response(/*int n*/);
int next_basenote(/*int n*/);
void yank_to_addr(/*char *orig, char *addr*/);
int show_last_page(/*void*/);
int match_header(/*char *buf, char *pat, char *body, int len*/);
/* post.c */
int user_posted_messages(/*void*/);
void update_art_posted_file(/*char *group, char *subj*/);
int post_base(/*char *group*/);
int post_response(/*char *group, int respnum*/);
int mail_to_someone(/*char *address*/);
int mail_bug_report(/*void*/);
int mail_to_author(/*int copy_text*/);
void find_new_to(/*char *nam, char *mail_to*/);
int cancel_article(/*void*/);
int submit_file(/*char *name*/);
/* prompt.c */
int parse_num(/*int ch, char *prompt*/);
int parse_string(/*char *prompt, char *buf*/);
int parse_menu_string(/*int line, int col, char *var*/);
int prompt_yn(/*int line, char *prompt, int default_ch*/);
void continue_prompt(/*void*/);
/* rcfile.c */
int read_rcfile(/*void*/);
void write_rcfile(/*void*/);
int change_rcfile(/*char *group, int kill_at_once*/);
void show_rcfile_menu(/*void*/);
void expand_rel_abs_pathname(/*int line, int col, char *str*/);
void show_menu_help(/*char *help_message*/);
/* save.c */
int save_art_to_file(/*int respnum, int index, int mailbox, char *filename*/);
int save_thread_to_file(/*int is_mailbox, char *group_path*/);
int save_regex_arts(/*int is_mailbox, char *group_path*/);
int append_to_existing_file(/*int i*/);
int create_path(/*char *path*/);
int create_sub_dir(/*int i*/);
void add_to_save_list(/*int index, struct header *article, int is_mailbox, char *path*/);
void sort_save_list(/*void*/);
int save_comp(/*char *p1, char *p2*/);
char *save_filename(/*int i*/);
char *get_first_savefile(/*void*/);
char *get_last_savefile(/*void*/);
int post_process_files(/*int proc_type_ch*/);
void post_process_uud(/*int pp*/);
void post_process_sh(/*void*/);
char *get_archive_file(/*char *dir, char *ext*/);
void delete_processed_files(/*void*/);
void post_process_patch(/*void*/);
/* screen.c */
void info_message(/*char *str*/);
void wait_message(/*char *str*/);
void error_message(/*char *template, char *str*/);
void clear_message(/*void*/);
void center_line(/*int line, int inverse, char *str*/);
void draw_arrow(/*int line*/);
void erase_arrow(/*int line*/);
/* search.c */
int search_author(/*int current_art, int forward*/);
void search_group(/*int forward*/);
void search_subject(/*int forward, char *group*/);
int search_article(/*int forward*/);
char *str_str(/*char *text, char *pattern*/);
void make_lower(/*char *s, char *t*/);
/* select.c */
void selection_index(/*int start_groupnum*/);
void group_selection_page(/*void*/);
int prompt_group_num(/*int ch*/);
void erase_group_arrow(/*void*/);
void draw_group_arrow(/*void*/);
int choose_new_group(/*void*/);
int add_group(/*char *s, int get_unread*/);
int next_unread(/*int n*/);
int prev_unread(/*int n*/);
int reposition_group(/*char *group, int default_num*/);
void catchup_group(/*int goto_next_unread_group*/);
void next_unread_group(/*int enter_group*/);
/* signal.c */
void set_signal_handlers(/*void*/);
void signal_handler(/*int sig*/);
void set_win_size(/*int *num_lines, int *num_cols*/);
void art_suspend(/*int sig*/);
void main_suspend(/*int sig*/);
void select_suspend(/*int sig*/);
void group_suspend(/*int sig*/);
void page_suspend(/*int sig*/);
void rcfile_suspend(/*int sig*/);
void art_resize(/*int sig*/);
void main_resize(/*int sig*/);
void select_resize(/*int sig*/);
void group_resize(/*int sig*/);
void page_resize(/*int sig*/);
/* wildmat.c */
int wildmat(/*char *text, char *p*/);
 
#endif
