/*
 *  Project   : tin - a visual threaded usenet newsreader
 *  Module    : screen.c
 *  Author    : R.Skrenta / I.Lea
 *  Created   : 01-04-91
 *  Updated   : 04-10-91
 *  Release   : 1.0
 *  Notes     :
 *  Copyright : (c) Copyright 1991 by Rich Skrenta & Iain Lea
 *	            You may  freely  copy or  redistribute  this software,
 *              so  long as there is no profit made from its use, sale
 *              trade or  reproduction.  You may not change this copy-
 *              right notice, and it must be included in any copy made
 */

#include	"tin.h"

extern int errno;

char msg[LEN];
struct screen_t *screen;


void info_message (str)
	char *str;
{
	clear_message();				/* Clear any old messages hanging around */
	center_line(LINES, FALSE, str);	/* center the message at screen bottom */
	MoveCursor(LINES, 0);
}


void wait_message (str)
	char *str;
{
	if (RawState ()) {
		clear_message();	  /* Clear any old messages hanging around */
	}
	printf ("%s", str);
	fflush (stdout);
}


void error_message (template, str)
	char *template;
	char *str;
{
	errno = 0;

	if (update == FALSE && RawState ()) {
		clear_message ();	  /* Clear any old messages hanging around */
	}
	
	fprintf (stderr, template, str);
	fflush (stderr);

	if (update == FALSE && RawState ()) {
		MoveCursor (LINES, 0);
		sleep (2);
	} else {
		fprintf (stderr, "\n");
		fflush (stderr);
	}
}


void clear_message ()
{
	MoveCursor(LINES, 0);
	CleartoEOLN();
}


void center_line (line, inverse, str)
	int line;
	int inverse;
	char *str;
{
	int pos;

	pos = (COLS - (int) strlen (str)) / 2;
	MoveCursor (line, pos);
	if (inverse) {
		StartInverse ();
	}
	printf ("%s", str);
	fflush (stdout);
	if (inverse) {
		EndInverse ();
	}
}


void draw_arrow (line)
	int line;
{
	MoveCursor (line, 0);

	if (draw_arrow_mark) {
		printf ("->");
		fflush (stdout);
	} else {
		StartInverse ();
		printf ("%s", screen[line-INDEX_TOP].col);
		fflush (stdout);
		EndInverse ();
	}
	MoveCursor (LINES, 0);
}


void erase_arrow (line)
	int line;
{
	MoveCursor (line, 0);

	if (draw_arrow_mark) {
		printf ("  ");
	} else {
		EndInverse ();
		printf ("%s", screen[line-INDEX_TOP].col);
	}
	fflush (stdout);
}
